/* Enumeration.c generated by valac 0.44.5, the Vala compiler
 * generated from Enumeration.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */
/* Serializable.vala
 *
 + Copyright (C) 2013  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define GXML_TYPE_ENUMERATION (gxml_enumeration_get_type ())
#define GXML_ENUMERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GXML_TYPE_ENUMERATION, GXmlEnumeration))
#define GXML_ENUMERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GXML_TYPE_ENUMERATION, GXmlEnumerationClass))
#define GXML_IS_ENUMERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GXML_TYPE_ENUMERATION))
#define GXML_IS_ENUMERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GXML_TYPE_ENUMERATION))
#define GXML_ENUMERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GXML_TYPE_ENUMERATION, GXmlEnumerationClass))

typedef struct _GXmlEnumeration GXmlEnumeration;
typedef struct _GXmlEnumerationClass GXmlEnumerationClass;
typedef struct _GXmlEnumerationPrivate GXmlEnumerationPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
typedef struct _GXmlParamSpecEnumeration GXmlParamSpecEnumeration;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GXmlEnumeration {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GXmlEnumerationPrivate * priv;
};

struct _GXmlEnumerationClass {
	GTypeClass parent_class;
	void (*finalize) (GXmlEnumeration *self);
};

typedef enum  {
	GXML_ENUMERATION_ERROR_INVALID_VALUE,
	GXML_ENUMERATION_ERROR_INVALID_TEXT
} GXmlEnumerationError;
#define GXML_ENUMERATION_ERROR gxml_enumeration_error_quark ()
struct _GXmlParamSpecEnumeration {
	GParamSpec parent_instance;
};

/**
   * Errors when de/serializing enumerations.
   */

static gpointer gxml_enumeration_parent_class = NULL;

gpointer gxml_enumeration_ref (gpointer instance);
void gxml_enumeration_unref (gpointer instance);
GParamSpec* gxml_param_spec_enumeration (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void gxml_value_set_enumeration (GValue* value,
                                 gpointer v_object);
void gxml_value_take_enumeration (GValue* value,
                                  gpointer v_object);
gpointer gxml_value_get_enumeration (const GValue* value);
GType gxml_enumeration_get_type (void) G_GNUC_CONST;
gchar* gxml_enumeration_get_nick (GType enumeration,
                                  gint val,
                                  GError** error);
gchar* gxml_enumeration_get_string (GType enumeration,
                                    gint val,
                                    gboolean use_nick,
                                    gboolean camelcase,
                                    GError** error);
gchar* gxml_enumeration_get_nick_camelcase (GType enumeration,
                                            gint val,
                                            GError** error);
void gxml_init_init (void);
static GEnumValue* _g_enum_value_dup (GEnumValue* self);
GQuark gxml_enumeration_error_quark (void);
GEnumValue* gxml_enumeration_parse (GType enumeration,
                                    const gchar* val,
                                    GError** error);
GEnumValue* gxml_enumeration_to_array (GType enumeration,
                                       gint* result_length1);
GEnumValue* gxml_enumeration_parse_integer (GType enumeration,
                                            gint val);
static GEnumValue* _vala_array_dup1 (GEnumValue* self,
                              int length);
gchar** gxml_enumeration_to_string_array (GType enumeration,
                                          gint* result_length1,
                                          GError** error);
static GEnumValue* _vala_array_dup2 (GEnumValue* self,
                              int length);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
GXmlEnumeration* gxml_enumeration_new (void);
GXmlEnumeration* gxml_enumeration_construct (GType object_type);
static void gxml_enumeration_finalize (GXmlEnumeration * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

/**
 * Introspect an enumeration to get value's nick name.
 *
 * Returns: an string representing an enumeration's value.
 *
 * @param enumeration a {@link GLib.Type} of type {@link GLib.Type.ENUM}
 * @param val an integer to parse an enum value of type @enumeration.
 */
gchar*
gxml_enumeration_get_nick (GType enumeration,
                           gint val,
                           GError** error)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 51 "../gxml/Enumeration.vala"
	_tmp1_ = gxml_enumeration_get_string (enumeration, val, TRUE, FALSE, &_inner_error0_);
#line 51 "../gxml/Enumeration.vala"
	_tmp0_ = _tmp1_;
#line 51 "../gxml/Enumeration.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 51 "../gxml/Enumeration.vala"
		g_propagate_error (error, _inner_error0_);
#line 51 "../gxml/Enumeration.vala"
		return NULL;
#line 162 "Enumeration.c"
	}
#line 51 "../gxml/Enumeration.vala"
	_tmp2_ = _tmp0_;
#line 51 "../gxml/Enumeration.vala"
	_tmp0_ = NULL;
#line 51 "../gxml/Enumeration.vala"
	result = _tmp2_;
#line 51 "../gxml/Enumeration.vala"
	_g_free0 (_tmp0_);
#line 51 "../gxml/Enumeration.vala"
	return result;
#line 174 "Enumeration.c"
}

/**
 * Introspect an enumeration to get value's nick name and transform
 * to camel case representation.
 *
 * Returns: an string representing an enumeration's value.
 *
 * @param enumeration a {@link GLib.Type} of type {@link GLib.Type.ENUM}
 * @param val an integer to parse an enum value of type @param enumeration.
 */
gchar*
gxml_enumeration_get_nick_camelcase (GType enumeration,
                                     gint val,
                                     GError** error)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 64 "../gxml/Enumeration.vala"
	_tmp1_ = gxml_enumeration_get_string (enumeration, val, FALSE, TRUE, &_inner_error0_);
#line 64 "../gxml/Enumeration.vala"
	_tmp0_ = _tmp1_;
#line 64 "../gxml/Enumeration.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../gxml/Enumeration.vala"
		g_propagate_error (error, _inner_error0_);
#line 64 "../gxml/Enumeration.vala"
		return NULL;
#line 206 "Enumeration.c"
	}
#line 64 "../gxml/Enumeration.vala"
	_tmp2_ = _tmp0_;
#line 64 "../gxml/Enumeration.vala"
	_tmp0_ = NULL;
#line 64 "../gxml/Enumeration.vala"
	result = _tmp2_;
#line 64 "../gxml/Enumeration.vala"
	_g_free0 (_tmp0_);
#line 64 "../gxml/Enumeration.vala"
	return result;
#line 218 "Enumeration.c"
}

/**
 * Transform enumeration's value to its string representation.
 *
 * Returns: an string representing an enumeration's value.
 *
 * @param enumeration a {@link GLib.Type} of type {@link GLib.Type.ENUM}
 * @param val an integer to parse an enum value of type @enumeration.
 * @param use_nick makes to returns value's nick name in {@link GLib.EnumClass}
 * @param camelcase makes to returns value's nick name in {@link GLib.EnumClass}
 * as camel case representation. If @use_nick is set this take no effect.
 */
static GEnumValue*
_g_enum_value_dup (GEnumValue* self)
{
	GEnumValue* dup;
#line 86 "../gxml/Enumeration.vala"
	dup = g_new0 (GEnumValue, 1);
#line 86 "../gxml/Enumeration.vala"
	memcpy (dup, self, sizeof (GEnumValue));
#line 86 "../gxml/Enumeration.vala"
	return dup;
#line 242 "Enumeration.c"
}

static gpointer
__g_enum_value_dup0 (gpointer self)
{
#line 86 "../gxml/Enumeration.vala"
	return self ? _g_enum_value_dup (self) : NULL;
#line 250 "Enumeration.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 267 "Enumeration.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
#line 1428 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1429 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1429 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1429 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1430 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1431 "glib-2.0.vapi"
		start = string_length + start;
#line 294 "Enumeration.c"
	}
#line 1433 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1434 "glib-2.0.vapi"
		end = string_length + end;
#line 300 "Enumeration.c"
	}
#line 1436 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 306 "Enumeration.c"
	} else {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 310 "Enumeration.c"
	}
#line 1436 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1437 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 318 "Enumeration.c"
	} else {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 322 "Enumeration.c"
	}
#line 1437 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1438 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1439 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1439 "glib-2.0.vapi"
	result = _tmp4_;
#line 1439 "glib-2.0.vapi"
	return result;
#line 334 "Enumeration.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1516 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1517 "glib-2.0.vapi"
	result = self;
#line 1517 "glib-2.0.vapi"
	return result;
#line 347 "Enumeration.c"
}

gchar*
gxml_enumeration_get_string (GType enumeration,
                             gint val,
                             gboolean use_nick,
                             gboolean camelcase,
                             GError** error)
{
	gchar* result = NULL;
	gchar* camel = NULL;
	gchar* _tmp0_;
	GEnumClass* enumc = NULL;
	GTypeClass* _tmp1_;
	GEnumValue* enumv = NULL;
	GEnumClass* _tmp2_;
	GEnumValue* _tmp3_;
	GEnumValue* _tmp4_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp12_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 77 "../gxml/Enumeration.vala"
	_vala_return_val_if_fail (g_type_is_a (enumeration, G_TYPE_ENUM), "enumeration.is_a (Type.ENUM)", NULL);
#line 83 "../gxml/Enumeration.vala"
	gxml_init_init ();
#line 84 "../gxml/Enumeration.vala"
	_tmp0_ = g_strdup ("");
#line 84 "../gxml/Enumeration.vala"
	camel = _tmp0_;
#line 85 "../gxml/Enumeration.vala"
	_tmp1_ = g_type_class_ref (enumeration);
#line 85 "../gxml/Enumeration.vala"
	enumc = (GEnumClass*) _tmp1_;
#line 86 "../gxml/Enumeration.vala"
	_tmp2_ = enumc;
#line 86 "../gxml/Enumeration.vala"
	_tmp3_ = __g_enum_value_dup0 (g_enum_get_value (_tmp2_, val));
#line 86 "../gxml/Enumeration.vala"
	enumv = _tmp3_;
#line 87 "../gxml/Enumeration.vala"
	_tmp4_ = enumv;
#line 87 "../gxml/Enumeration.vala"
	if (_tmp4_ == NULL) {
#line 391 "Enumeration.c"
		GError* _tmp5_;
#line 88 "../gxml/Enumeration.vala"
		_tmp5_ = g_error_new_literal (GXML_ENUMERATION_ERROR, GXML_ENUMERATION_ERROR_INVALID_VALUE, _ ("value is invalid"));
#line 88 "../gxml/Enumeration.vala"
		_inner_error0_ = _tmp5_;
#line 88 "../gxml/Enumeration.vala"
		g_propagate_error (error, _inner_error0_);
#line 88 "../gxml/Enumeration.vala"
		_g_free0 (enumv);
#line 88 "../gxml/Enumeration.vala"
		_g_type_class_unref0 (enumc);
#line 88 "../gxml/Enumeration.vala"
		_g_free0 (camel);
#line 88 "../gxml/Enumeration.vala"
		return NULL;
#line 407 "Enumeration.c"
	}
#line 89 "../gxml/Enumeration.vala"
	if (use_nick) {
#line 411 "Enumeration.c"
		GEnumValue* _tmp7_;
		const gchar* _tmp8_;
#line 89 "../gxml/Enumeration.vala"
		_tmp7_ = enumv;
#line 89 "../gxml/Enumeration.vala"
		_tmp8_ = (*_tmp7_).value_nick;
#line 89 "../gxml/Enumeration.vala"
		_tmp6_ = _tmp8_ != NULL;
#line 420 "Enumeration.c"
	} else {
#line 89 "../gxml/Enumeration.vala"
		_tmp6_ = FALSE;
#line 424 "Enumeration.c"
	}
#line 89 "../gxml/Enumeration.vala"
	if (_tmp6_) {
#line 428 "Enumeration.c"
		GEnumValue* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 90 "../gxml/Enumeration.vala"
		_tmp9_ = enumv;
#line 90 "../gxml/Enumeration.vala"
		_tmp10_ = (*_tmp9_).value_nick;
#line 90 "../gxml/Enumeration.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 90 "../gxml/Enumeration.vala"
		result = _tmp11_;
#line 90 "../gxml/Enumeration.vala"
		_g_free0 (enumv);
#line 90 "../gxml/Enumeration.vala"
		_g_type_class_unref0 (enumc);
#line 90 "../gxml/Enumeration.vala"
		_g_free0 (camel);
#line 90 "../gxml/Enumeration.vala"
		return result;
#line 448 "Enumeration.c"
	}
#line 91 "../gxml/Enumeration.vala"
	if (camelcase) {
#line 452 "Enumeration.c"
		GEnumValue* _tmp13_;
		const gchar* _tmp14_;
#line 91 "../gxml/Enumeration.vala"
		_tmp13_ = enumv;
#line 91 "../gxml/Enumeration.vala"
		_tmp14_ = (*_tmp13_).value_nick;
#line 91 "../gxml/Enumeration.vala"
		_tmp12_ = _tmp14_ != NULL;
#line 461 "Enumeration.c"
	} else {
#line 91 "../gxml/Enumeration.vala"
		_tmp12_ = FALSE;
#line 465 "Enumeration.c"
	}
#line 91 "../gxml/Enumeration.vala"
	if (_tmp12_) {
#line 469 "Enumeration.c"
		gchar** sp = NULL;
		GEnumValue* _tmp15_;
		const gchar* _tmp16_;
		gchar** _tmp17_;
		gchar** _tmp18_;
		gint sp_length1;
		gint _sp_size_;
		gchar** _tmp19_;
		gint _tmp19__length1;
#line 92 "../gxml/Enumeration.vala"
		_tmp15_ = enumv;
#line 92 "../gxml/Enumeration.vala"
		_tmp16_ = (*_tmp15_).value_nick;
#line 92 "../gxml/Enumeration.vala"
		_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, "-", 0);
#line 92 "../gxml/Enumeration.vala"
		sp = _tmp18_;
#line 92 "../gxml/Enumeration.vala"
		sp_length1 = _vala_array_length (_tmp17_);
#line 92 "../gxml/Enumeration.vala"
		_sp_size_ = sp_length1;
#line 93 "../gxml/Enumeration.vala"
		_tmp19_ = sp;
#line 93 "../gxml/Enumeration.vala"
		_tmp19__length1 = sp_length1;
#line 495 "Enumeration.c"
		{
			gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 93 "../gxml/Enumeration.vala"
			s_collection = _tmp19_;
#line 93 "../gxml/Enumeration.vala"
			s_collection_length1 = _tmp19__length1;
#line 93 "../gxml/Enumeration.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 507 "Enumeration.c"
				gchar* _tmp20_;
				gchar* s = NULL;
#line 93 "../gxml/Enumeration.vala"
				_tmp20_ = g_strdup (s_collection[s_it]);
#line 93 "../gxml/Enumeration.vala"
				s = _tmp20_;
#line 514 "Enumeration.c"
				{
					const gchar* _tmp21_;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					gint _tmp29_;
					gint _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					const gchar* _tmp33_;
					gchar* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
#line 94 "../gxml/Enumeration.vala"
					_tmp21_ = camel;
#line 94 "../gxml/Enumeration.vala"
					_tmp22_ = s;
#line 94 "../gxml/Enumeration.vala"
					_tmp23_ = g_strdup_printf ("%c", string_get (_tmp22_, (glong) 0));
#line 94 "../gxml/Enumeration.vala"
					_tmp24_ = _tmp23_;
#line 94 "../gxml/Enumeration.vala"
					_tmp25_ = g_utf8_strup (_tmp24_, (gssize) -1);
#line 94 "../gxml/Enumeration.vala"
					_tmp26_ = _tmp25_;
#line 94 "../gxml/Enumeration.vala"
					_tmp27_ = s;
#line 94 "../gxml/Enumeration.vala"
					_tmp28_ = s;
#line 94 "../gxml/Enumeration.vala"
					_tmp29_ = strlen (_tmp28_);
#line 94 "../gxml/Enumeration.vala"
					_tmp30_ = _tmp29_;
#line 94 "../gxml/Enumeration.vala"
					_tmp31_ = string_slice (_tmp27_, (glong) 1, (glong) _tmp30_);
#line 94 "../gxml/Enumeration.vala"
					_tmp32_ = _tmp31_;
#line 94 "../gxml/Enumeration.vala"
					_tmp33_ = string_to_string (_tmp32_);
#line 94 "../gxml/Enumeration.vala"
					_tmp34_ = g_strconcat (_tmp26_, _tmp33_, NULL);
#line 94 "../gxml/Enumeration.vala"
					_tmp35_ = _tmp34_;
#line 94 "../gxml/Enumeration.vala"
					_tmp36_ = g_strconcat (_tmp21_, _tmp35_, NULL);
#line 94 "../gxml/Enumeration.vala"
					_g_free0 (camel);
#line 94 "../gxml/Enumeration.vala"
					camel = _tmp36_;
#line 94 "../gxml/Enumeration.vala"
					_g_free0 (_tmp35_);
#line 94 "../gxml/Enumeration.vala"
					_g_free0 (_tmp32_);
#line 94 "../gxml/Enumeration.vala"
					_g_free0 (_tmp26_);
#line 94 "../gxml/Enumeration.vala"
					_g_free0 (_tmp24_);
#line 93 "../gxml/Enumeration.vala"
					_g_free0 (s);
#line 578 "Enumeration.c"
				}
			}
		}
#line 91 "../gxml/Enumeration.vala"
		sp = (_vala_array_free (sp, sp_length1, (GDestroyNotify) g_free), NULL);
#line 584 "Enumeration.c"
	} else {
		GEnumValue* _tmp37_;
		const gchar* _tmp38_;
		gchar* _tmp39_;
#line 98 "../gxml/Enumeration.vala"
		_tmp37_ = enumv;
#line 98 "../gxml/Enumeration.vala"
		_tmp38_ = (*_tmp37_).value_name;
#line 98 "../gxml/Enumeration.vala"
		_tmp39_ = g_strdup (_tmp38_);
#line 98 "../gxml/Enumeration.vala"
		_g_free0 (camel);
#line 98 "../gxml/Enumeration.vala"
		camel = _tmp39_;
#line 599 "Enumeration.c"
	}
#line 99 "../gxml/Enumeration.vala"
	result = camel;
#line 99 "../gxml/Enumeration.vala"
	_g_free0 (enumv);
#line 99 "../gxml/Enumeration.vala"
	_g_type_class_unref0 (enumc);
#line 99 "../gxml/Enumeration.vala"
	return result;
#line 609 "Enumeration.c"
}

/**
 * Parse @val to an enumeration's value.
 * 
 * Returns: an {@link GLib.EnumValue} representing an enumeration's value.
 * 
 * @param enumeration a {@link GLib.Type} of type {@link GLib.Type.ENUM}
 * @param val a string to parse an enum value of type @param enumeration.
 * as camel case representation. If @use_nick is set this take no effect.
 */
GEnumValue*
gxml_enumeration_parse (GType enumeration,
                        const gchar* val,
                        GError** error)
{
	GEnumValue* result = NULL;
	GEnumClass* enumc = NULL;
	GTypeClass* _tmp0_;
	GEnumValue* enumv = NULL;
	GEnumClass* _tmp1_;
	GEnumValue* _tmp2_;
	gint _tmp2__length1;
	GEnumValue* _tmp24_;
	GError* _inner_error0_ = NULL;
#line 110 "../gxml/Enumeration.vala"
	g_return_val_if_fail (val != NULL, NULL);
#line 110 "../gxml/Enumeration.vala"
	_vala_return_val_if_fail (g_type_is_a (enumeration, G_TYPE_ENUM), "enumeration.is_a (Type.ENUM)", NULL);
#line 114 "../gxml/Enumeration.vala"
	gxml_init_init ();
#line 115 "../gxml/Enumeration.vala"
	_tmp0_ = g_type_class_ref (enumeration);
#line 115 "../gxml/Enumeration.vala"
	enumc = (GEnumClass*) _tmp0_;
#line 116 "../gxml/Enumeration.vala"
	enumv = NULL;
#line 117 "../gxml/Enumeration.vala"
	_tmp1_ = enumc;
#line 117 "../gxml/Enumeration.vala"
	_tmp2_ = _tmp1_->values;
#line 117 "../gxml/Enumeration.vala"
	_tmp2__length1 = _tmp1_->n_values;
#line 653 "Enumeration.c"
	{
		GEnumValue* ev_collection = NULL;
		gint ev_collection_length1 = 0;
		gint _ev_collection_size_ = 0;
		gint ev_it = 0;
#line 117 "../gxml/Enumeration.vala"
		ev_collection = _tmp2_;
#line 117 "../gxml/Enumeration.vala"
		ev_collection_length1 = _tmp2__length1;
#line 117 "../gxml/Enumeration.vala"
		for (ev_it = 0; ev_it < ev_collection_length1; ev_it = ev_it + 1) {
#line 665 "Enumeration.c"
			GEnumValue ev = {0};
#line 117 "../gxml/Enumeration.vala"
			ev = ev_collection[ev_it];
#line 669 "Enumeration.c"
			{
				GEnumValue _tmp3_;
				const gchar* _tmp4_;
				GEnumValue _tmp7_;
				const gchar* _tmp8_;
				gchar* nick = NULL;
				GEnumValue _tmp11_;
				gchar* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gboolean _tmp21_;
#line 118 "../gxml/Enumeration.vala"
				_tmp3_ = ev;
#line 118 "../gxml/Enumeration.vala"
				_tmp4_ = _tmp3_.value_name;
#line 118 "../gxml/Enumeration.vala"
				if (g_strcmp0 (val, _tmp4_) == 0) {
#line 691 "Enumeration.c"
					GEnumValue _tmp5_;
					GEnumValue* _tmp6_;
#line 119 "../gxml/Enumeration.vala"
					_tmp5_ = ev;
#line 119 "../gxml/Enumeration.vala"
					_tmp6_ = __g_enum_value_dup0 (&_tmp5_);
#line 119 "../gxml/Enumeration.vala"
					_g_free0 (enumv);
#line 119 "../gxml/Enumeration.vala"
					enumv = _tmp6_;
#line 702 "Enumeration.c"
				}
#line 120 "../gxml/Enumeration.vala"
				_tmp7_ = ev;
#line 120 "../gxml/Enumeration.vala"
				_tmp8_ = _tmp7_.value_nick;
#line 120 "../gxml/Enumeration.vala"
				if (g_strcmp0 (val, _tmp8_) == 0) {
#line 710 "Enumeration.c"
					GEnumValue _tmp9_;
					GEnumValue* _tmp10_;
#line 121 "../gxml/Enumeration.vala"
					_tmp9_ = ev;
#line 121 "../gxml/Enumeration.vala"
					_tmp10_ = __g_enum_value_dup0 (&_tmp9_);
#line 121 "../gxml/Enumeration.vala"
					_g_free0 (enumv);
#line 121 "../gxml/Enumeration.vala"
					enumv = _tmp10_;
#line 721 "Enumeration.c"
				}
#line 122 "../gxml/Enumeration.vala"
				_tmp11_ = ev;
#line 122 "../gxml/Enumeration.vala"
				_tmp12_ = gxml_enumeration_get_nick_camelcase (enumeration, _tmp11_.value, &_inner_error0_);
#line 122 "../gxml/Enumeration.vala"
				nick = _tmp12_;
#line 122 "../gxml/Enumeration.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "../gxml/Enumeration.vala"
					g_propagate_error (error, _inner_error0_);
#line 122 "../gxml/Enumeration.vala"
					_g_free0 (enumv);
#line 122 "../gxml/Enumeration.vala"
					_g_type_class_unref0 (enumc);
#line 122 "../gxml/Enumeration.vala"
					return NULL;
#line 739 "Enumeration.c"
				}
#line 123 "../gxml/Enumeration.vala"
				_tmp13_ = nick;
#line 123 "../gxml/Enumeration.vala"
				if (g_strcmp0 (val, _tmp13_) == 0) {
#line 745 "Enumeration.c"
					GEnumValue _tmp14_;
					GEnumValue* _tmp15_;
#line 124 "../gxml/Enumeration.vala"
					_tmp14_ = ev;
#line 124 "../gxml/Enumeration.vala"
					_tmp15_ = __g_enum_value_dup0 (&_tmp14_);
#line 124 "../gxml/Enumeration.vala"
					_g_free0 (enumv);
#line 124 "../gxml/Enumeration.vala"
					enumv = _tmp15_;
#line 756 "Enumeration.c"
				}
#line 125 "../gxml/Enumeration.vala"
				_tmp16_ = g_utf8_strdown (val, (gssize) -1);
#line 125 "../gxml/Enumeration.vala"
				_tmp17_ = _tmp16_;
#line 125 "../gxml/Enumeration.vala"
				_tmp18_ = nick;
#line 125 "../gxml/Enumeration.vala"
				_tmp19_ = g_utf8_strdown (_tmp18_, (gssize) -1);
#line 125 "../gxml/Enumeration.vala"
				_tmp20_ = _tmp19_;
#line 125 "../gxml/Enumeration.vala"
				_tmp21_ = g_strcmp0 (_tmp17_, _tmp20_) == 0;
#line 125 "../gxml/Enumeration.vala"
				_g_free0 (_tmp20_);
#line 125 "../gxml/Enumeration.vala"
				_g_free0 (_tmp17_);
#line 125 "../gxml/Enumeration.vala"
				if (_tmp21_) {
#line 776 "Enumeration.c"
					GEnumValue _tmp22_;
					GEnumValue* _tmp23_;
#line 126 "../gxml/Enumeration.vala"
					_tmp22_ = ev;
#line 126 "../gxml/Enumeration.vala"
					_tmp23_ = __g_enum_value_dup0 (&_tmp22_);
#line 126 "../gxml/Enumeration.vala"
					_g_free0 (enumv);
#line 126 "../gxml/Enumeration.vala"
					enumv = _tmp23_;
#line 787 "Enumeration.c"
				}
#line 117 "../gxml/Enumeration.vala"
				_g_free0 (nick);
#line 791 "Enumeration.c"
			}
		}
	}
#line 128 "../gxml/Enumeration.vala"
	_tmp24_ = enumv;
#line 128 "../gxml/Enumeration.vala"
	if (_tmp24_ == NULL) {
#line 799 "Enumeration.c"
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GError* _tmp28_;
		GError* _tmp29_;
#line 129 "../gxml/Enumeration.vala"
		_tmp25_ = g_type_name (enumeration);
#line 129 "../gxml/Enumeration.vala"
		_tmp26_ = g_strconcat (_ ("text cannot be parsed to enumeration type:"), _tmp25_, NULL);
#line 129 "../gxml/Enumeration.vala"
		_tmp27_ = _tmp26_;
#line 129 "../gxml/Enumeration.vala"
		_tmp28_ = g_error_new_literal (GXML_ENUMERATION_ERROR, GXML_ENUMERATION_ERROR_INVALID_TEXT, _tmp27_);
#line 129 "../gxml/Enumeration.vala"
		_tmp29_ = _tmp28_;
#line 129 "../gxml/Enumeration.vala"
		_g_free0 (_tmp27_);
#line 129 "../gxml/Enumeration.vala"
		_inner_error0_ = _tmp29_;
#line 129 "../gxml/Enumeration.vala"
		g_propagate_error (error, _inner_error0_);
#line 129 "../gxml/Enumeration.vala"
		_g_free0 (enumv);
#line 129 "../gxml/Enumeration.vala"
		_g_type_class_unref0 (enumc);
#line 129 "../gxml/Enumeration.vala"
		return NULL;
#line 827 "Enumeration.c"
	}
#line 130 "../gxml/Enumeration.vala"
	result = enumv;
#line 130 "../gxml/Enumeration.vala"
	_g_type_class_unref0 (enumc);
#line 130 "../gxml/Enumeration.vala"
	return result;
#line 835 "Enumeration.c"
}

/**
 * Transform an enumeration in an array of {@link GLib.EnumValue}.
 * 
 * Returns: an array of {@link GLib.EnumValue} representing an enumeration.
 * 
 * @param enumeration a {@link GLib.Type} of type {@link GLib.Type.ENUM}
 */
GEnumValue*
gxml_enumeration_to_array (GType enumeration,
                           gint* result_length1)
{
	GEnumValue* result = NULL;
	GEnumClass* enumc = NULL;
	GTypeClass* _tmp0_;
	GEnumValue* _tmp1_;
	gint _tmp1__length1;
	GEnumValue* _tmp2_;
	gint _tmp2__length1;
#line 139 "../gxml/Enumeration.vala"
	_vala_return_val_if_fail (g_type_is_a (enumeration, G_TYPE_ENUM), "enumeration.is_a (Type.ENUM)", NULL);
#line 142 "../gxml/Enumeration.vala"
	gxml_init_init ();
#line 143 "../gxml/Enumeration.vala"
	_tmp0_ = g_type_class_ref (enumeration);
#line 143 "../gxml/Enumeration.vala"
	enumc = (GEnumClass*) _tmp0_;
#line 144 "../gxml/Enumeration.vala"
	_tmp1_ = enumc->values;
#line 144 "../gxml/Enumeration.vala"
	_tmp1__length1 = enumc->n_values;
#line 144 "../gxml/Enumeration.vala"
	_tmp2_ = _tmp1_;
#line 144 "../gxml/Enumeration.vala"
	_tmp2__length1 = _tmp1__length1;
#line 144 "../gxml/Enumeration.vala"
	if (result_length1) {
#line 144 "../gxml/Enumeration.vala"
		*result_length1 = _tmp2__length1;
#line 876 "Enumeration.c"
	}
#line 144 "../gxml/Enumeration.vala"
	result = _tmp2_;
#line 144 "../gxml/Enumeration.vala"
	_g_type_class_unref0 (enumc);
#line 144 "../gxml/Enumeration.vala"
	return result;
#line 884 "Enumeration.c"
}

/**
 * From a integer valuer calculates a valid {@link GLib.EnumValue} for a
 * {@link GLib.Type}. 
 *
 * Returns: a {@link GLib.EnumValue} or null if fails.
 *
 * @param enumeration a {@link GLib.Type} of type {@link GLib.Type.ENUM}
 * @param val an integer in a valid range in the enumeration.
 */
static GEnumValue*
_vala_array_dup1 (GEnumValue* self,
                  int length)
{
#line 159 "../gxml/Enumeration.vala"
	return g_memdup (self, length * sizeof (GEnumValue));
#line 902 "Enumeration.c"
}

GEnumValue*
gxml_enumeration_parse_integer (GType enumeration,
                                gint val)
{
	GEnumValue* result = NULL;
	GEnumValue* vals = NULL;
	gint _tmp0_ = 0;
	GEnumValue* _tmp1_;
	GEnumValue* _tmp2_;
	gint _tmp2__length1;
	gint vals_length1;
	gint _vals_size_;
	GEnumValue* _tmp3_;
	gint _tmp3__length1;
#line 157 "../gxml/Enumeration.vala"
	gxml_init_init ();
#line 158 "../gxml/Enumeration.vala"
	if (!g_type_is_a (enumeration, G_TYPE_ENUM)) {
#line 158 "../gxml/Enumeration.vala"
		result = NULL;
#line 158 "../gxml/Enumeration.vala"
		return result;
#line 927 "Enumeration.c"
	}
#line 159 "../gxml/Enumeration.vala"
	_tmp1_ = gxml_enumeration_to_array (enumeration, &_tmp0_);
#line 159 "../gxml/Enumeration.vala"
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup1 (_tmp1_, _tmp0_) : ((gpointer) _tmp1_);
#line 159 "../gxml/Enumeration.vala"
	_tmp2__length1 = _tmp0_;
#line 159 "../gxml/Enumeration.vala"
	vals = _tmp2_;
#line 159 "../gxml/Enumeration.vala"
	vals_length1 = _tmp2__length1;
#line 159 "../gxml/Enumeration.vala"
	_vals_size_ = vals_length1;
#line 160 "../gxml/Enumeration.vala"
	_tmp3_ = vals;
#line 160 "../gxml/Enumeration.vala"
	_tmp3__length1 = vals_length1;
#line 160 "../gxml/Enumeration.vala"
	if (_tmp3_ == NULL) {
#line 160 "../gxml/Enumeration.vala"
		result = NULL;
#line 160 "../gxml/Enumeration.vala"
		vals = (g_free (vals), NULL);
#line 160 "../gxml/Enumeration.vala"
		return result;
#line 953 "Enumeration.c"
	}
	{
		gint i = 0;
#line 161 "../gxml/Enumeration.vala"
		i = 0;
#line 959 "Enumeration.c"
		{
			gboolean _tmp4_ = FALSE;
#line 161 "../gxml/Enumeration.vala"
			_tmp4_ = TRUE;
#line 161 "../gxml/Enumeration.vala"
			while (TRUE) {
#line 966 "Enumeration.c"
				GEnumValue* _tmp6_;
				gint _tmp6__length1;
				GEnumValue e = {0};
				GEnumValue* _tmp7_;
				gint _tmp7__length1;
				GEnumValue _tmp8_;
				GEnumValue _tmp9_;
#line 161 "../gxml/Enumeration.vala"
				if (!_tmp4_) {
#line 976 "Enumeration.c"
					gint _tmp5_;
#line 161 "../gxml/Enumeration.vala"
					_tmp5_ = i;
#line 161 "../gxml/Enumeration.vala"
					i = _tmp5_ + 1;
#line 982 "Enumeration.c"
				}
#line 161 "../gxml/Enumeration.vala"
				_tmp4_ = FALSE;
#line 161 "../gxml/Enumeration.vala"
				_tmp6_ = vals;
#line 161 "../gxml/Enumeration.vala"
				_tmp6__length1 = vals_length1;
#line 161 "../gxml/Enumeration.vala"
				if (!(i < _tmp6__length1)) {
#line 161 "../gxml/Enumeration.vala"
					break;
#line 994 "Enumeration.c"
				}
#line 162 "../gxml/Enumeration.vala"
				_tmp7_ = vals;
#line 162 "../gxml/Enumeration.vala"
				_tmp7__length1 = vals_length1;
#line 162 "../gxml/Enumeration.vala"
				_tmp8_ = _tmp7_[i];
#line 162 "../gxml/Enumeration.vala"
				e = _tmp8_;
#line 163 "../gxml/Enumeration.vala"
				_tmp9_ = e;
#line 163 "../gxml/Enumeration.vala"
				if (_tmp9_.value == val) {
#line 1008 "Enumeration.c"
					GEnumValue* _tmp10_;
#line 163 "../gxml/Enumeration.vala"
					_tmp10_ = __g_enum_value_dup0 (&e);
#line 163 "../gxml/Enumeration.vala"
					result = _tmp10_;
#line 163 "../gxml/Enumeration.vala"
					vals = (g_free (vals), NULL);
#line 163 "../gxml/Enumeration.vala"
					return result;
#line 1018 "Enumeration.c"
				}
			}
		}
	}
#line 165 "../gxml/Enumeration.vala"
	result = NULL;
#line 165 "../gxml/Enumeration.vala"
	vals = (g_free (vals), NULL);
#line 165 "../gxml/Enumeration.vala"
	return result;
#line 1029 "Enumeration.c"
}

/**
 * Transform an enumeration in an array of strings representing enumeration values.
 *
 * Returns: an array of strings representing an enumeration.
 *
 * @param enumeration a {@link GLib.Type} of type {@link GLib.Type.ENUM}
 */
static GEnumValue*
_vala_array_dup2 (GEnumValue* self,
                  int length)
{
#line 178 "../gxml/Enumeration.vala"
	return g_memdup (self, length * sizeof (GEnumValue));
#line 1045 "Enumeration.c"
}

static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 181 "../gxml/Enumeration.vala"
	if ((*length) == (*size)) {
#line 181 "../gxml/Enumeration.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 181 "../gxml/Enumeration.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1060 "Enumeration.c"
	}
#line 181 "../gxml/Enumeration.vala"
	(*array)[(*length)++] = value;
#line 181 "../gxml/Enumeration.vala"
	(*array)[*length] = NULL;
#line 1066 "Enumeration.c"
}

gchar**
gxml_enumeration_to_string_array (GType enumeration,
                                  gint* result_length1,
                                  GError** error)
{
	gchar** result = NULL;
	GEnumValue* vals = NULL;
	gint _tmp0_ = 0;
	GEnumValue* _tmp1_;
	GEnumValue* _tmp2_;
	gint _tmp2__length1;
	gint vals_length1;
	gint _vals_size_;
	gchar** s = NULL;
	gchar** _tmp3_;
	gint s_length1;
	gint _s_size_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GError* _inner_error0_ = NULL;
#line 174 "../gxml/Enumeration.vala"
	_vala_return_val_if_fail (g_type_is_a (enumeration, G_TYPE_ENUM), "enumeration.is_a (Type.ENUM)", NULL);
#line 177 "../gxml/Enumeration.vala"
	gxml_init_init ();
#line 178 "../gxml/Enumeration.vala"
	_tmp1_ = gxml_enumeration_to_array (enumeration, &_tmp0_);
#line 178 "../gxml/Enumeration.vala"
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup2 (_tmp1_, _tmp0_) : ((gpointer) _tmp1_);
#line 178 "../gxml/Enumeration.vala"
	_tmp2__length1 = _tmp0_;
#line 178 "../gxml/Enumeration.vala"
	vals = _tmp2_;
#line 178 "../gxml/Enumeration.vala"
	vals_length1 = _tmp2__length1;
#line 178 "../gxml/Enumeration.vala"
	_vals_size_ = vals_length1;
#line 179 "../gxml/Enumeration.vala"
	_tmp3_ = g_new0 (gchar*, 0 + 1);
#line 179 "../gxml/Enumeration.vala"
	s = _tmp3_;
#line 179 "../gxml/Enumeration.vala"
	s_length1 = 0;
#line 179 "../gxml/Enumeration.vala"
	_s_size_ = s_length1;
#line 1113 "Enumeration.c"
	{
		gint i = 0;
#line 180 "../gxml/Enumeration.vala"
		i = 0;
#line 1118 "Enumeration.c"
		{
			gboolean _tmp4_ = FALSE;
#line 180 "../gxml/Enumeration.vala"
			_tmp4_ = TRUE;
#line 180 "../gxml/Enumeration.vala"
			while (TRUE) {
#line 1125 "Enumeration.c"
				GEnumValue* _tmp6_;
				gint _tmp6__length1;
				gchar* _tmp7_ = NULL;
				GEnumValue* _tmp8_;
				gint _tmp8__length1;
				GEnumValue _tmp9_;
				gchar* _tmp10_;
				gchar** _tmp11_;
				gint _tmp11__length1;
				gchar* _tmp12_;
#line 180 "../gxml/Enumeration.vala"
				if (!_tmp4_) {
#line 1138 "Enumeration.c"
					gint _tmp5_;
#line 180 "../gxml/Enumeration.vala"
					_tmp5_ = i;
#line 180 "../gxml/Enumeration.vala"
					i = _tmp5_ + 1;
#line 1144 "Enumeration.c"
				}
#line 180 "../gxml/Enumeration.vala"
				_tmp4_ = FALSE;
#line 180 "../gxml/Enumeration.vala"
				_tmp6_ = vals;
#line 180 "../gxml/Enumeration.vala"
				_tmp6__length1 = vals_length1;
#line 180 "../gxml/Enumeration.vala"
				if (!(i < _tmp6__length1)) {
#line 180 "../gxml/Enumeration.vala"
					break;
#line 1156 "Enumeration.c"
				}
#line 181 "../gxml/Enumeration.vala"
				_tmp8_ = vals;
#line 181 "../gxml/Enumeration.vala"
				_tmp8__length1 = vals_length1;
#line 181 "../gxml/Enumeration.vala"
				_tmp9_ = _tmp8_[i];
#line 181 "../gxml/Enumeration.vala"
				_tmp10_ = gxml_enumeration_get_nick_camelcase (enumeration, _tmp9_.value, &_inner_error0_);
#line 181 "../gxml/Enumeration.vala"
				_tmp7_ = _tmp10_;
#line 181 "../gxml/Enumeration.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "../gxml/Enumeration.vala"
					g_propagate_error (error, _inner_error0_);
#line 181 "../gxml/Enumeration.vala"
					s = (_vala_array_free (s, s_length1, (GDestroyNotify) g_free), NULL);
#line 181 "../gxml/Enumeration.vala"
					vals = (g_free (vals), NULL);
#line 181 "../gxml/Enumeration.vala"
					return NULL;
#line 1178 "Enumeration.c"
				}
#line 181 "../gxml/Enumeration.vala"
				_tmp11_ = s;
#line 181 "../gxml/Enumeration.vala"
				_tmp11__length1 = s_length1;
#line 181 "../gxml/Enumeration.vala"
				_tmp12_ = _tmp7_;
#line 181 "../gxml/Enumeration.vala"
				_tmp7_ = NULL;
#line 181 "../gxml/Enumeration.vala"
				_vala_array_add1 (&s, &s_length1, &_s_size_, _tmp12_);
#line 180 "../gxml/Enumeration.vala"
				_g_free0 (_tmp7_);
#line 1192 "Enumeration.c"
			}
		}
	}
#line 183 "../gxml/Enumeration.vala"
	_tmp13_ = s;
#line 183 "../gxml/Enumeration.vala"
	_tmp13__length1 = s_length1;
#line 183 "../gxml/Enumeration.vala"
	if (result_length1) {
#line 183 "../gxml/Enumeration.vala"
		*result_length1 = _tmp13__length1;
#line 1204 "Enumeration.c"
	}
#line 183 "../gxml/Enumeration.vala"
	result = _tmp13_;
#line 183 "../gxml/Enumeration.vala"
	vals = (g_free (vals), NULL);
#line 183 "../gxml/Enumeration.vala"
	return result;
#line 1212 "Enumeration.c"
}

GXmlEnumeration*
gxml_enumeration_construct (GType object_type)
{
	GXmlEnumeration* self = NULL;
#line 39 "../gxml/Enumeration.vala"
	self = (GXmlEnumeration*) g_type_create_instance (object_type);
#line 39 "../gxml/Enumeration.vala"
	return self;
#line 1223 "Enumeration.c"
}

GXmlEnumeration*
gxml_enumeration_new (void)
{
#line 39 "../gxml/Enumeration.vala"
	return gxml_enumeration_construct (GXML_TYPE_ENUMERATION);
#line 1231 "Enumeration.c"
}

static void
gxml_value_enumeration_init (GValue* value)
{
#line 39 "../gxml/Enumeration.vala"
	value->data[0].v_pointer = NULL;
#line 1239 "Enumeration.c"
}

static void
gxml_value_enumeration_free_value (GValue* value)
{
#line 39 "../gxml/Enumeration.vala"
	if (value->data[0].v_pointer) {
#line 39 "../gxml/Enumeration.vala"
		gxml_enumeration_unref (value->data[0].v_pointer);
#line 1249 "Enumeration.c"
	}
}

static void
gxml_value_enumeration_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 39 "../gxml/Enumeration.vala"
	if (src_value->data[0].v_pointer) {
#line 39 "../gxml/Enumeration.vala"
		dest_value->data[0].v_pointer = gxml_enumeration_ref (src_value->data[0].v_pointer);
#line 1261 "Enumeration.c"
	} else {
#line 39 "../gxml/Enumeration.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1265 "Enumeration.c"
	}
}

static gpointer
gxml_value_enumeration_peek_pointer (const GValue* value)
{
#line 39 "../gxml/Enumeration.vala"
	return value->data[0].v_pointer;
#line 1274 "Enumeration.c"
}

static gchar*
gxml_value_enumeration_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 39 "../gxml/Enumeration.vala"
	if (collect_values[0].v_pointer) {
#line 1285 "Enumeration.c"
		GXmlEnumeration * object;
		object = collect_values[0].v_pointer;
#line 39 "../gxml/Enumeration.vala"
		if (object->parent_instance.g_class == NULL) {
#line 39 "../gxml/Enumeration.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1292 "Enumeration.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 39 "../gxml/Enumeration.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1296 "Enumeration.c"
		}
#line 39 "../gxml/Enumeration.vala"
		value->data[0].v_pointer = gxml_enumeration_ref (object);
#line 1300 "Enumeration.c"
	} else {
#line 39 "../gxml/Enumeration.vala"
		value->data[0].v_pointer = NULL;
#line 1304 "Enumeration.c"
	}
#line 39 "../gxml/Enumeration.vala"
	return NULL;
#line 1308 "Enumeration.c"
}

static gchar*
gxml_value_enumeration_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	GXmlEnumeration ** object_p;
	object_p = collect_values[0].v_pointer;
#line 39 "../gxml/Enumeration.vala"
	if (!object_p) {
#line 39 "../gxml/Enumeration.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1323 "Enumeration.c"
	}
#line 39 "../gxml/Enumeration.vala"
	if (!value->data[0].v_pointer) {
#line 39 "../gxml/Enumeration.vala"
		*object_p = NULL;
#line 1329 "Enumeration.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 39 "../gxml/Enumeration.vala"
		*object_p = value->data[0].v_pointer;
#line 1333 "Enumeration.c"
	} else {
#line 39 "../gxml/Enumeration.vala"
		*object_p = gxml_enumeration_ref (value->data[0].v_pointer);
#line 1337 "Enumeration.c"
	}
#line 39 "../gxml/Enumeration.vala"
	return NULL;
#line 1341 "Enumeration.c"
}

GParamSpec*
gxml_param_spec_enumeration (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	GXmlParamSpecEnumeration* spec;
#line 39 "../gxml/Enumeration.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GXML_TYPE_ENUMERATION), NULL);
#line 39 "../gxml/Enumeration.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 39 "../gxml/Enumeration.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 39 "../gxml/Enumeration.vala"
	return G_PARAM_SPEC (spec);
#line 1360 "Enumeration.c"
}

gpointer
gxml_value_get_enumeration (const GValue* value)
{
#line 39 "../gxml/Enumeration.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GXML_TYPE_ENUMERATION), NULL);
#line 39 "../gxml/Enumeration.vala"
	return value->data[0].v_pointer;
#line 1370 "Enumeration.c"
}

void
gxml_value_set_enumeration (GValue* value,
                            gpointer v_object)
{
	GXmlEnumeration * old;
#line 39 "../gxml/Enumeration.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GXML_TYPE_ENUMERATION));
#line 39 "../gxml/Enumeration.vala"
	old = value->data[0].v_pointer;
#line 39 "../gxml/Enumeration.vala"
	if (v_object) {
#line 39 "../gxml/Enumeration.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GXML_TYPE_ENUMERATION));
#line 39 "../gxml/Enumeration.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 39 "../gxml/Enumeration.vala"
		value->data[0].v_pointer = v_object;
#line 39 "../gxml/Enumeration.vala"
		gxml_enumeration_ref (value->data[0].v_pointer);
#line 1392 "Enumeration.c"
	} else {
#line 39 "../gxml/Enumeration.vala"
		value->data[0].v_pointer = NULL;
#line 1396 "Enumeration.c"
	}
#line 39 "../gxml/Enumeration.vala"
	if (old) {
#line 39 "../gxml/Enumeration.vala"
		gxml_enumeration_unref (old);
#line 1402 "Enumeration.c"
	}
}

void
gxml_value_take_enumeration (GValue* value,
                             gpointer v_object)
{
	GXmlEnumeration * old;
#line 39 "../gxml/Enumeration.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GXML_TYPE_ENUMERATION));
#line 39 "../gxml/Enumeration.vala"
	old = value->data[0].v_pointer;
#line 39 "../gxml/Enumeration.vala"
	if (v_object) {
#line 39 "../gxml/Enumeration.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GXML_TYPE_ENUMERATION));
#line 39 "../gxml/Enumeration.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 39 "../gxml/Enumeration.vala"
		value->data[0].v_pointer = v_object;
#line 1423 "Enumeration.c"
	} else {
#line 39 "../gxml/Enumeration.vala"
		value->data[0].v_pointer = NULL;
#line 1427 "Enumeration.c"
	}
#line 39 "../gxml/Enumeration.vala"
	if (old) {
#line 39 "../gxml/Enumeration.vala"
		gxml_enumeration_unref (old);
#line 1433 "Enumeration.c"
	}
}

static void
gxml_enumeration_class_init (GXmlEnumerationClass * klass,
                             gpointer klass_data)
{
#line 39 "../gxml/Enumeration.vala"
	gxml_enumeration_parent_class = g_type_class_peek_parent (klass);
#line 39 "../gxml/Enumeration.vala"
	((GXmlEnumerationClass *) klass)->finalize = gxml_enumeration_finalize;
#line 1445 "Enumeration.c"
}

static void
gxml_enumeration_instance_init (GXmlEnumeration * self,
                                gpointer klass)
{
#line 39 "../gxml/Enumeration.vala"
	self->ref_count = 1;
#line 1454 "Enumeration.c"
}

static void
gxml_enumeration_finalize (GXmlEnumeration * obj)
{
	GXmlEnumeration * self;
#line 39 "../gxml/Enumeration.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_ENUMERATION, GXmlEnumeration);
#line 39 "../gxml/Enumeration.vala"
	g_signal_handlers_destroy (self);
#line 1465 "Enumeration.c"
}

/**
 * Convenient static methods for enumeration serialization to string.
 * 
 * Enumerations have a set of utility methods to better represent on
 * serialisation/deserialization.
 * 
 * Enumerations could be converted to string using its definition on {@link GLib.EnumClass},
 * by taking its nick name directly or converting to its camel case representation.
 * 
 * Any enumeration value type in a <code>GLib.Object</code>'s property could be
 * deserialized from its definition given on {@link GLib.EnumClass} (name and
 * nick) or from its camel case representation.
 */
GType
gxml_enumeration_get_type (void)
{
	static volatile gsize gxml_enumeration_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_enumeration_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gxml_value_enumeration_init, gxml_value_enumeration_free_value, gxml_value_enumeration_copy_value, gxml_value_enumeration_peek_pointer, "p", gxml_value_enumeration_collect_value, "p", gxml_value_enumeration_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GXmlEnumerationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_enumeration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlEnumeration), 0, (GInstanceInitFunc) gxml_enumeration_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gxml_enumeration_type_id;
		gxml_enumeration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GXmlEnumeration", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gxml_enumeration_type_id__volatile, gxml_enumeration_type_id);
	}
	return gxml_enumeration_type_id__volatile;
}

gpointer
gxml_enumeration_ref (gpointer instance)
{
	GXmlEnumeration * self;
	self = instance;
#line 39 "../gxml/Enumeration.vala"
	g_atomic_int_inc (&self->ref_count);
#line 39 "../gxml/Enumeration.vala"
	return instance;
#line 1505 "Enumeration.c"
}

void
gxml_enumeration_unref (gpointer instance)
{
	GXmlEnumeration * self;
	self = instance;
#line 39 "../gxml/Enumeration.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 39 "../gxml/Enumeration.vala"
		GXML_ENUMERATION_GET_CLASS (self)->finalize (self);
#line 39 "../gxml/Enumeration.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1519 "Enumeration.c"
	}
}

GQuark
gxml_enumeration_error_quark (void)
{
#line 28 "../gxml/Collections.vala"
	return g_quark_from_static_string ("gxml-enumeration-error-quark");
#line 1528 "Enumeration.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
#line 28 "../gxml/Collections.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1538 "Enumeration.c"
		int i;
#line 28 "../gxml/Collections.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 28 "../gxml/Collections.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 28 "../gxml/Collections.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1546 "Enumeration.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
#line 28 "../gxml/Collections.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 28 "../gxml/Collections.vala"
	g_free (array);
#line 1561 "Enumeration.c"
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
#line 28 "../gxml/Collections.vala"
	if (array) {
#line 28 "../gxml/Collections.vala"
		while (((gpointer*) array)[length]) {
#line 28 "../gxml/Collections.vala"
			length++;
#line 1575 "Enumeration.c"
		}
	}
#line 28 "../gxml/Collections.vala"
	return length;
#line 1580 "Enumeration.c"
}

